pipeline {
 agent any
 stages {
  stage('Checkout Repositories') {
   steps {
    dir('chain-agent') {
     git credentialsId: 'JenkinsAENEAS', url: 'git@gitlab.com:aenco/blockchain/Chain-Agent.git'
    }
    dir('configurator') {
     git credentialsId: 'JenkinsAENEAS', url: 'git@github.com:AENCO-Global/Chain-Management-System.git'
    }
   }
  }

  stage('Compile') {
   steps {
    dir('chain-agent') {
     script {
      app = docker.build("aenco/chain-agent", "--build-arg BUILD_ID=${env.BUILD_ID} .")
     }
    }
   }
  }

  stage('Test Core Image') {
   steps {
    script {
     app.inside {
      // TODO Insert tests here
      sh 'echo "Tests passed"'
     }
    }
   }
  }

  stage('Push Core Image') {
   steps {
    script {
     docker.withRegistry('https://registry.hub.docker.com', 'DockerAEN') {
      app.push()
     }
    }
    // Copy the chain agent configuration file to the configurator repository
    fileOperations([fileCopyOperation(excludes: '', flattenFiles: true, includes: 'chain-agent/resources/config-agent.ini.twig', targetLocation: 'configurator/server/templates/configs/v1/common')])
    fileOperations([fileCopyOperation(excludes: '', flattenFiles: true, includes: 'chain-agent/resources/config-agent.ini.twig', targetLocation: 'configurator/server/templates/configs/v2/common')])
    script {
     dir('configurator') {
      sshagent(['JenkinsAENEAS']) {
      sh "git add ."
      sh "git diff-index --quiet HEAD || git commit -a -m 'Config agent update'"
      sh "git push origin master"
      }
     }
    }
   }
  }
 }
}
